PlayMateGram/examples.p

Some examples of the toy PlayMateGram at work.

These examples use the parser and generator -- written in pop-11,
and based on the Pop-11 TEACH GRAMMAR and LIB GRAMMAR packages:
	
	PlayMateGram/newgrammar.p

using the grammar and lexicon in here:

	PlayMateGram/newplaylex.p

Running a selection of the examples in:

	PlayMateGram/test_playlex.p
	
===================================================================
Each example is in the form of
	<parseproc>(<list of words>) ==>

Where <parseproc> invokes a function to parse an instance
of one of the categories defined in newplaylex.p

Each example is followed by a printout of the parse tree
produced (using Pop-11's simple pretty-printer "==>")

No claim is made or implied that any of this is of use in a real
robot. It was merely a test of some ideas, including the use of an
'ill-formed' substring table (hashing on expressions previously
found not to be parseable as being of a certain type).

The addition of that mechanism produced a massive speedup (from
several minutes in some cases to a fraction of a second on the
linux machine on my desktop).

Because of the way pop-11's itemiser works by default (it can be
modified) I use a double quote symbol " instead of singlequote '
for apostrophes. So, instead of
	Nick's

I use
	Nick"s

which pop-11 parses as three words Nick " s

This may make some of the examples a little confusing at first.

===================================================================

;;; After this, the examples below should work.
compilehere
	test_playlex.p
	;

typenp([thing in front of the car]) ==>
** [typenp [noun thing]
           [rel_descr [loc_pp [front_prepp in front of]
                              [np_obj [nonagent_np [detnp [det the] [typenp [noun car]]]]]]]]


typenp_pl([things in front of the car]) ==>
** [typenp_pl [noun_pl things]
              [rel_descr_pl
               [loc_pp [front_prepp in front of]
                       [np_obj [nonagent_np [detnp [det the] [typenp [noun car]]]]]]]]


typenp([blue thing in front of the car which is in the red box]) ==>
** [typenp [adjes [adj [simpadj [colouradj blue]]]]
           [noun thing]
           [rel_descr [loc_pp [front_prepp in front of]
                              [np_obj [nonagent_np
                                       [detnp [det the]
                                              [typenp [noun car]
                                                      [rel_descr which is
                                                                 [loc_pp [loc_prep in]
                                                                         [np_obj [nonagent_np
                                                                                  [detnp [det

	  the]
                                                                                         [typenp

	     [adjes

	            [adj

	                 [simpadj

	                          [colouradj

	                                     red]]]]

	     [noun

	           box]]]]]]]]]]]]]]


rel_descr([in the red box on the table]) ==>
** [rel_descr [loc_pp [loc_prep in]
                      [np_obj [nonagent_np
                               [detnp [det the]
                                      [typenp [adjes [adj [simpadj [colouradj red]]]]
                                              [noun box]
                                              [rel_descr [loc_pp [loc_prep on]
                                                                 [np_obj [nonagent_np
                                                                          [detnp [det the]
                                                                                 [typenp [noun

	   table]]]]]]]]]]]]]

S([the car is red]) ==>
** [S [assertion [np_subj [nonagent_np [detnp [det the] [typenp [noun car]]]]]
                 [is_verb [is_v is]]
                 [complement [complement_simple [adj [simpadj [colouradj red]]]]]]]


S([the car was red]) ==>
** [S [assertion [np_subj [nonagent_np [detnp [det the] [typenp [noun car]]]]]
                 [is_verb [is_v was]]
                 [complement [complement_simple [adj [simpadj [colouradj red]]]]]]]


S([put the red thing in front of the car]) ==>
** [S [command [agent_dovp
                [do_putverb_pp put]
                [np_obj [nonagent_np
                         [detnp [det the]
                                [typenp [adjes [adj [simpadj [colouradj red]]]]
                                        [noun thing]]]]]
                [dest_pp [front_prepp in front of]
                         [np_obj [nonagent_np [detnp [det the] [typenp [noun car]]]]]]]]]


S([move the red thing to the left of the blue thing]) ==>
** [S [command [agent_dovp
                [do_pushverb move]
                [push_obj [np_obj [nonagent_np
                                   [detnp [det the]
                                          [typenp [adjes [adj [simpadj [colouradj red]]]]
                                                  [noun thing]]]]]
                          [move_loc [target_pp [to_pp to
                                                      [loc_type [det the]
                                                                [loc_rel [loc_hor left]]
                                                                of
                                                                [np_obj [nonagent_np
                                                                         [detnp [det the]
                                                                                [typenp [adjes

	   [adj

	        [simpadj

	                 [colouradj

	                            blue]]]]
                                                                                        [noun

	  thing]]]]]]]]]]]]]


S([move the red thing from the left of the blue thing to the right of the green thing]) ==>
** [S [command [agent_dovp
                [do_pushverb move]
                [push_obj [np_obj [nonagent_np
                                   [detnp [det the]
                                          [typenp [adjes [adj [simpadj [colouradj red]]]]
                                                  [noun thing]]]]]
                          [move_loc [source_pp [source_prep from]
                                               [loc_type [det the]
                                                         [loc_rel [loc_hor left]]
                                                         of
                                                         [np_obj [nonagent_np
                                                                  [detnp [det the]
                                                                         [typenp [adjes [adj

	 [simpadj

	          [colouradj

	                     blue]]]]
                                                                                 [noun thing]]]]]]]
                                    [target_pp [to_pp to
                                                      [loc_type [det the]
                                                                [loc_rel [loc_hor right]]
                                                                of
                                                                [np_obj [nonagent_np
                                                                         [detnp [det the]
                                                                                [typenp [adjes

	   [adj

	        [simpadj

	                 [colouradj

	                            green]]]]
                                                                                        [noun

	  thing]]]]]]]]]]]]]



S([what is near the red ball])==>
** [S [question [what_question
                 [what_word what]
                 [is_verb [is_v is]]
                 [complement
                  [complement_simple
                   [loc_pp [loc_prep near]
                           [np_obj [nonagent_np
                                    [detnp [det the]
                                           [typenp [adjes [adj [simpadj [colouradj red]]]]
                                                   [noun ball]]]]]]]]]]]


S([what is to the left of the red ball])==>
** [S [question [what_question
                 [what_word what]
                 [is_verb [is_v is]]
                 [complement
                  [complement_simple
                   [to_pp to
                          [loc_type [det the]
                                    [loc_rel [loc_hor left]]
                                    of
                                    [np_obj [nonagent_np
                                             [detnp [det the]
                                                    [typenp [adjes [adj [simpadj [colouradj

	red]]]]
                                                            [noun ball]]]]]]]]]]]]



S([what is not under the table])==>
** [S [question [what_question
                 [what_word what]
                 [is_verb [is_v is]]
                 [complement
                  not
                  [complement_simple
                   [loc_pp [loc_prep under]
                           [np_obj [nonagent_np [detnp [det the] [typenp [noun table]]]]]]]]]]]



S([is the red square blue and big])==>
** [S [question [is_question
                 [is_v is]
                 [np_subj [nonagent_np
                           [detnp [det the]
                                  [typenp [adjes [adj [simpadj [colouradj red]]]]
                                          [noun square]]]]]
                 [complement
                  [complement_simple [adj [simpadj [colouradj blue]]]]
                  and
                  [complement_simple [adj [simpadj [sizeadj big]]]]]]]]


S([is the red square to the left of the box on the table])==>
** [S [question [is_question
                 [is_v is]
                 [np_subj [nonagent_np
                           [detnp [det the]
                                  [typenp [adjes [adj [simpadj [colouradj red]]]]
                                          [noun square]]]]]
                 [complement
                  [complement_simple
                   [to_pp to
                          [loc_type [det the]
                                    [loc_rel [loc_hor left]]
                                    of
                                    [np_obj [nonagent_np
                                             [detnp [det the]
                                                    [typenp [noun box]
                                                            [rel_descr [loc_pp [loc_prep on]
                                                                               [np_obj [nonagent_np
                                                                                        [detnp

	   [det

	        the]

	   [typenp

	           [noun

	                 table]]]]]]]]]]]]]]]]]]


S([what was in front of the big red cow])==>
** [S [question [what_question
                 [what_word what]
                 [is_verb [is_v was]]
                 [complement
                  [complement_simple
                   [loc_pp [front_prepp in front of]
                           [np_obj [nonagent_np
                                    [detnp [det the]
                                           [typenp [adjes [adj [simpadj [sizeadj big]]]
                                                          [adjes [adj [simpadj [colouradj red]]]]]
                                                   [noun cow]]]]]]]]]]]


S([what was not in front of the big red cow])==>
** [S [question [what_question
                 [what_word what]
                 [is_verb [is_v was]]
                 [complement
                  not
                  [complement_simple
                   [loc_pp [front_prepp in front of]
                           [np_obj [nonagent_np
                                    [detnp [det the]
                                           [typenp [adjes [adj [simpadj [sizeadj big]]]
                                                          [adjes [adj [simpadj [colouradj red]]]]]
                                                   [noun cow]]]]]]]]]]]


S([what is in front of the ball]) ==>
** [S [question [what_question
                 [what_word what]
                 [is_verb [is_v is]]
                 [complement
                  [complement_simple
                   [loc_pp [front_prepp in front of]
                           [np_obj [nonagent_np [detnp [det the] [typenp [noun ball]]]]]]]]]]]



S([Nick"s red car is big and heavy]) ==>
** [S [assertion [np_subj [pos_np [possessive [person_name Nick] " s]
                                  [typenp [adjes [adj [simpadj [colouradj red]]]]
                                          [noun car]]]]
                 [is_verb [is_v is]]
                 [complement
                  [complement_simple [adj [simpadj [sizeadj big]]]]
                  and
                  [complement_simple [adj [simpadj [sizeadj heavy]]]]]]]


S([can Nick look at the red ball and pick it up]) ==>
** [S [question [can_question
                 can
                 [np_subj [agent_np_subj [person_name Nick]]]
                 [agent_dovp
                  [do_sensevp look at]
                  [np_obj [nonagent_np
                           [detnp [det the]
                                  [typenp [adjes [adj [simpadj [colouradj red]]]]
                                          [noun ball]]]]]]
                 and
                 [agent_dovp
                  [do_pickverb pick]
                  [pick_obj [np_obj [nonagent_np [thing_pronoun it]]] up]]]]]



S([look at the red ball and fetch it from under the box]) ==>
** [S [command [command [agent_dovp
                         [do_sensevp look at]
                         [np_obj [nonagent_np
                                  [detnp [det the]
                                         [typenp [adjes [adj [simpadj [colouradj red]]]]
                                                 [noun ball]]]]]]]
               and
               [command [agent_dovp
                         [do_getverb_pp fetch]
                         [np_obj [nonagent_np [thing_pronoun it]]]
                         [move_loc [source_pp [source_prep from]
                                              [loc_pp [loc_prep under]
                                                      [np_obj [nonagent_np
                                                               [detnp [det the]
                                                                      [typenp [noun box]]]]]]]]]]]]


S([take the ball to the kitchen and put the box in the bedroom])==>
** [S [command [command [agent_dovp
                         [do_getverb_pp take]
                         [np_obj [nonagent_np [detnp [det the] [typenp [noun ball]]]]]
                         [move_loc [target_pp [target_prep to]
                                              [np_obj [nonagent_np
                                                       [detnp [det the]
                                                              [typenp [noun kitchen]]]]]]]]]
               and
               [command [agent_dovp
                         [do_putverb_pp put]
                         [np_obj [nonagent_np [detnp [det the] [typenp [noun box]]]]]
                         [dest_pp [dest_prep in]
                                  [np_obj [nonagent_np
                                           [detnp [det the] [typenp [noun bedroom]]]]]]]]]]


S([after the ball is in the kitchen  put the box in the bedroom])==>
** [S [command after
               [assertion [np_subj [nonagent_np [detnp [det the] [typenp [noun ball]]]]]
                          [is_verb [is_v is]]
                          [complement
                           [complement_simple
                            [loc_pp [loc_prep in]
                                    [np_obj [nonagent_np
                                             [detnp [det the] [typenp [noun kitchen]]]]]]]]]
               [command [agent_dovp
                         [do_putverb_pp put]
                         [np_obj [nonagent_np [detnp [det the] [typenp [noun box]]]]]
                         [dest_pp [dest_prep in]
                                  [np_obj [nonagent_np
                                           [detnp [det the] [typenp [noun bedroom]]]]]]]]]]



question([where is the red car"s bonnet]) ==>
** [question [where_question
              where is
              [np_subj [pos_np [possessive
                                [nonagent_np
                                 [detnp [det the]
                                        [typenp [adjes [adj [simpadj [colouradj red]]]]
                                                [noun car]]]]
                                " s]
                               [typenp [noun bonnet]]]]]]


S([where are the car"s doors])==>
** [S [question [where_question
                 where are
                 [np_subj_pl
                  [pos_np_pl [possessive
                              [nonagent_np [detnp [det the] [typenp [noun car]]]]
                              " s]
                             [typenp_pl [noun_pl doors]]]]]]]

repeat 20 times
	generate_category(oneof([assertion question command]), toygram, toylex)==>
endrepeat


** [can Box2 throw Box2 and Box1 close to a right side of that]
** [PlayMate " s upright study which is next to them leaves her near some top of them]
** [PlayMate cannot look at some bathrooms in front of her]
** [She can come towards a horses]
** [now]
** [stop and stop]
** [the other corridor was not not Tray1]
** [what is the location of Robbie " s non heavy round doors that are near you]
** [PlayMate " s wheel was not between Box2 and Ball2 and him or not between GJ " s thin door
             and that " s green cow]
** [Jeremy was not that]
** [what comes onto some left side of that from in front of the boxes]
** [did you come to any front face of Box2 and Box1]
** [Tray1 is Nick]
** [what is the colour of this " s triangular corridors that are close to you]
** [what weight was Nick]
** [start]
** [Henrik can place that " s triangles or he cannot place that squares on some bicycles]
** [start]
** [where are those]
** [start or move GJ " s cubes in front of that or lift some bathrooms up]
